Index: /trunk/src/lib/collision_reaction/collision_handle.cc
===================================================================
--- /trunk/src/lib/collision_reaction/collision_handle.cc	(revision 8494)
+++ /trunk/src/lib/collision_reaction/collision_handle.cc	(revision 8495)
@@ -1,4 +1,4 @@
 /*
-   orxonox - the future of 3D-vertical-scrollers
+   orxonox - the future of 3D-vertical-scrollersf
 
    Copyright (C) 2004 orx
@@ -101,6 +101,7 @@
       return;
 
-  // add element
-   PRINTF(0)("addTarget: %i \n", target);
+   // add element
+   //PRINTF(0)("addTarget: %i \n", target);
+
    this->targetList.push_back(target);
 }
Index: /trunk/src/lib/graphics/effects/atmospheric_engine.cc
===================================================================
--- /trunk/src/lib/graphics/effects/atmospheric_engine.cc	(revision 8494)
+++ /trunk/src/lib/graphics/effects/atmospheric_engine.cc	(revision 8495)
@@ -30,7 +30,6 @@
  * @param root The XML-element to load the AtmosphericEngine from
  */
-AtmosphericEngine::AtmosphericEngine()
-{
-  this->setClassID(CL_ATMOSPHERIC_ENGINE, "AtmosphericEngine");
+AtmosphericEngine::AtmosphericEngine() {
+    this->setClassID(CL_ATMOSPHERIC_ENGINE, "AtmosphericEngine");
 }
 
@@ -44,15 +43,13 @@
  *  destroys a AtmosphericEngine
  */
-AtmosphericEngine::~AtmosphericEngine()
-{
-  AtmosphericEngine::singletonRef = NULL;
+AtmosphericEngine::~AtmosphericEngine() {
+    AtmosphericEngine::singletonRef = NULL;
 
-  const std::list<BaseObject*>* weatherEffects = ClassList::getList( CL_WEATHER_EFFECT);
+    const std::list<BaseObject*>* weatherEffects = ClassList::getList( CL_WEATHER_EFFECT);
 
-  if (weatherEffects != NULL)
-  {
-      while(!weatherEffects->empty())
-        delete weatherEffects->front();
-  }
+    if (weatherEffects != NULL) {
+        while(!weatherEffects->empty())
+            delete weatherEffects->front();
+    }
 }
 
@@ -60,8 +57,7 @@
  * @param root The XML-element to load the AtmosphericEngine from
  */
-void AtmosphericEngine::loadParams(const TiXmlElement* root)
-{
-  LoadParamXML(root, "WeatherEffect", this, AtmosphericEngine, loadWeatherEffect);
-  LoadParamXML(root, "SunEffect", this, AtmosphericEngine, loadSunEffect);
+void AtmosphericEngine::loadParams(const TiXmlElement* root) {
+    LoadParamXML(root, "WeatherEffect", this, AtmosphericEngine, loadWeatherEffect);
+    LoadParamXML(root, "SunEffect", this, AtmosphericEngine, loadSunEffect);
 }
 
@@ -69,16 +65,15 @@
  * @param root The XML-element to load WeatherEffects from
  */
-void AtmosphericEngine::loadWeatherEffect(const TiXmlElement* root)
-{
-  LOAD_PARAM_START_CYCLE(root, element);
-  {
-    PRINTF(4)("element is: %s\n", element->Value());
-    // Factory::fabricate(element);
+void AtmosphericEngine::loadWeatherEffect(const TiXmlElement* root) {
+    LOAD_PARAM_START_CYCLE(root, element);
+    {
+        PRINTF(4)("element is: %s\n", element->Value());
+        // Factory::fabricate(element);
 
-    BaseObject* bo = Factory::fabricate(element);
-    if( bo == NULL)
-      PRINTF(0)(" Could not create Element %s\n", element->Value());
-  }
-  LOAD_PARAM_END_CYCLE(element);
+        BaseObject* bo = Factory::fabricate(element);
+        if( bo == NULL)
+            PRINTF(0)(" Could not create Element %s\n", element->Value());
+    }
+    LOAD_PARAM_END_CYCLE(element);
 }
 
@@ -86,11 +81,10 @@
  * @param root The XML-element to load SunEffects from
  */
-void AtmosphericEngine::loadSunEffect(const TiXmlElement* root)
-{
-  LOAD_PARAM_START_CYCLE(root, element);
-  {
-    PRINTF(4)("element is: %s\n", element->Value());
-  }
-  LOAD_PARAM_END_CYCLE(element);
+void AtmosphericEngine::loadSunEffect(const TiXmlElement* root) {
+    LOAD_PARAM_START_CYCLE(root, element);
+    {
+        PRINTF(4)("element is: %s\n", element->Value());
+    }
+    LOAD_PARAM_END_CYCLE(element);
 }
 
@@ -99,15 +93,13 @@
  * draws the effect, if needed
  */
-void AtmosphericEngine::draw() const
-{
-  const std::list<BaseObject*>* weatherEffects = ClassList::getList( CL_WEATHER_EFFECT);
+void AtmosphericEngine::draw() const {
+    const std::list<BaseObject*>* weatherEffects = ClassList::getList( CL_WEATHER_EFFECT);
 
-  // draw the weather effects
-  if (weatherEffects != NULL)
-  {
-    std::list<BaseObject*>::const_iterator it;
-    for (it = weatherEffects->begin(); it != weatherEffects->end(); it++)
-      dynamic_cast<WeatherEffect*>(*it)->draw();
-  }
+    // draw the weather effects
+    if (weatherEffects != NULL) {
+        std::list<BaseObject*>::const_iterator it;
+        for (it = weatherEffects->begin(); it != weatherEffects->end(); it++)
+            dynamic_cast<WeatherEffect*>(*it)->draw();
+    }
 }
 
@@ -117,17 +109,14 @@
  * ticks the effect if there is any time dependancy
  */
-void AtmosphericEngine::tick(float dt)
-{
-  const std::list<BaseObject*>* weatherEffects = ClassList::getList( CL_WEATHER_EFFECT);
+void AtmosphericEngine::tick(float dt) {
+    const std::list<BaseObject*>* weatherEffects = ClassList::getList( CL_WEATHER_EFFECT);
 
-  // tick the weather effects
-  if (weatherEffects != NULL)
-  {
-    std::list<BaseObject*>::const_iterator it;
-    for (it = weatherEffects->begin(); it != weatherEffects->end(); it++)
-    {
-/*      printf("%s::%s \n", (*it)->getClassName(), (*it)->getName());*/
-      dynamic_cast<WeatherEffect*>(*it)->tick(dt);
+    // tick the weather effects
+    if (weatherEffects != NULL) {
+        std::list<BaseObject*>::const_iterator it;
+        for (it = weatherEffects->begin(); it != weatherEffects->end(); it++) {
+            /*      printf("%s::%s \n", (*it)->getClassName(), (*it)->getName());*/
+            dynamic_cast<WeatherEffect*>(*it)->tick(dt);
+        }
     }
-  }
 }
Index: /trunk/src/lib/graphics/effects/cloud_effect.cc
===================================================================
--- /trunk/src/lib/graphics/effects/cloud_effect.cc	(revision 8494)
+++ /trunk/src/lib/graphics/effects/cloud_effect.cc	(revision 8495)
@@ -21,5 +21,4 @@
 #include "util/loading/resource_manager.h"
 
-#include "glincl.h"
 #include "material.h"
 #include <math.h>
@@ -31,5 +30,4 @@
 #include "parser/tinyxml/tinyxml.h"
 
-#include "sglmodel.h"
 
 using namespace std;
@@ -43,4 +41,5 @@
 {
 	this->setClassID(CL_CLOUD_EFFECT, "CloudEffect");
+//  this->toList(OM_ENVIRON);
 
 	this->init();
@@ -49,5 +48,5 @@
 		this->loadParams(root);
 
-	if(cloudActivate)
+	//if(cloudActivate)
 		this->activate();
 }
@@ -56,45 +55,35 @@
 {
 	this->deactivate();
-
-	delete this->cloudMaterial;
-
-	cloudModel.Delete();
-	Shader::unload(this->cloudShader);
-
 }
 
 
-bool CloudEffect::init()
+void CloudEffect::init()
 {
-	PRINTF(1)("Initializing CloudEffect\n");
+	PRINTF(0)("Initializing CloudEffect\n");
+  
+    /// initialization of the texture coords, speeds etc...
+/*  this->move = 0.0f;
+  this->g_WaterUV = 35.0f;
+  this->kNormalMapScale = 0.25f;
+  this->g_WaterFlow = 0.0015f;*/
+  
+  cloudMaterial.setDiffuseMap("pictures/sky/cloud1.jpg", GL_TEXTURE_2D, 0);
 
-	// Default values
-	this->cloudActivate = false;
-	this->cloudTint[4] = ( 0.9f, 0.7f, 0.7f, 1.0f );
-	this->cloudScroll = 1.0f;
-	this->time = 0.0f;
-	//g_cloud_texture = 0;
+  shader = new Shader(ResourceManager::getInstance()->getDataDir() + "/shaders/cloud.vert",
+                      ResourceManager::getInstance()->getDataDir() + "/shaders/cloud.frag");
+  
+  this->shader->activateShader();
 
-	this->cloudTexture = "pictures/sky/cloud1.jpg";
-
-	cloudModel.Load("sky.sgl");
-	cloudModel.Unitize();
-
-	// Get the bounding box of the sky dome
-	float bbox[3] = {0};
-	cloudModel.GetDimensions(bbox[0], bbox[1], bbox[2]);
-	
-	// Load Shaders
-	this->cloudShader = new Shader( ResourceManager::getInstance()->getDataDir() + "/shaders/sky.vert", ResourceManager::getInstance()->getDataDir() +"/shaders/sky.frag");
-
-	// Tell the shader the bounding box of the sky dome
-	this->cloudShader->bindShader("bbox", bbox, 4);
-
-	// Initialze Cloud Material
-	this->cloudMaterial = new Material("Sky");
-	this->cloudMaterial->setIllum(3);
-	this->cloudMaterial->setAmbient(1.0, 1.0, 1.0);
-	this->cloudMaterial->setDiffuseMap(this->cloudTexture);
-
+  Shader::Uniform(shader, "Noise").set(0);
+  Shader::Uniform(shader, "SkyColor").set(0.0f, 0.0f, 0.8f);
+  Shader::Uniform(shader, "CloudColor").set(0.8f, 0.8f, 0.8f);
+  
+  // Change: Have to be updated each frame!like camerpos in mapped_water.cc
+  Shader::Uniform(shader, "Offset").set(0.0f, 0.0f, 0.0f);
+  
+  Shader::Uniform(shader, "LightPos").set(100.0f, 100.0f, 100.0f);
+  Shader::Uniform(shader, "Scale").set(1.0f);
+  
+  this->shader->deactivateShader();
 }
 
@@ -106,118 +95,64 @@
 	// LoadParam(root, "speed", this, CloudEffect, setCloudAnimation);
 	// LoadParam(root, "texture", this, CloudEffect, setCloudTexture);
-
+  /*
 	LOAD_PARAM_START_CYCLE(root, element);
 	{
 		LoadParam_CYCLE(element, "option", this, CloudEffect, setCloudOption);
 	}
-	LOAD_PARAM_END_CYCLE(element);
+  LOAD_PARAM_END_CYCLE(element);*/
 }
 
 
-bool CloudEffect::activate()
+void CloudEffect::activate()
 {
-	PRINTF(0)( "Activating CloudEffect with Material %s\n", this->cloudTexture.c_str());
+	PRINTF(0)( "Activating\n");
 
-	this->cloudActivate = true;
-	
+//	this->cloudActivate = true;
 }
 
-bool CloudEffect::deactivate()
+void CloudEffect::deactivate()
 {
 	PRINTF(0)("Deactivating CloudEffect\n");
 
-	this->cloudActivate = false;
+//	this->cloudActivate = false;
 }
 
 void CloudEffect::draw() const
 {
-	if (!this->cloudActivate)
-		return;
-		
-	// 	glMatrixMode(GL_MODELVIEW);
-	// 	glPushMatrix();
-	//
-	// 	// Move sphere along with the camera
-	// 	Vector r = State::getCameraNode()->getAbsCoor();
-	// 	glTranslatef(r.x, r.y, r.z);
-	//
-	// 	// Sky movement
-	// 	glRotatef(mover, 0, 0, 1);
-	//
-	// 	cloudMaterial->select();
-	// 	gluSphere(this->sphereObj, this->sphereRadius, 20, 20);
-	// 	glPopMatrix();
+	//if (!this->cloudActivate)
+	//	return;
 
-	// ******
+  //glMatrixMode(GL_MODELVIEW);
+  //glColor4f(1,1,1,1);
+  glPushMatrix();
+  //glTranslatef(0,this->waterHeight,0);
 
-	glMatrixMode(GL_MODELVIEW);
-	glPushMatrix();
+  cloudMaterial.unselect();
+  cloudMaterial.select();
 
-	// glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
-	// glShadeModel(GL_SMOOTH);
-	// glEnable(GL_DEPTH_TEST);
-	// glEnable(GL_CULL_FACE);
-	// glCullFace(GL_BACK);
-	// glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
-	
-	// glLineWidth(3.0f);
+  this->shader->activateShader();
 
-	static float time = 0.0f;
-	// static vector3f eye = {0.0f, 0.0f, 0.0f}, look = {0.0f, 0.0f, 1.0f}, up = {0.0f, 1.0f, 0.0f};
 
-	// glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-	// glLoadIdentity();
-	// gluLookAt(eye[x], eye[y], eye[z], look[x], look[y], look[z], up[x], up[y], up[z]);
+  glBegin(GL_QUADS);
+  
+  glTexCoord2f(1.0f, 1.0f); glVertex3f(0.0f, 0.0f,  0.0f);
+  glTexCoord2f(0.0f, 1.0f); glVertex3f( 0.0f, 0.0f,  100.0f);
+  glTexCoord2f(0.0f, 0.0f); glVertex3f( 100.0f, 0.0f,  100.0f);
+  glTexCoord2f(1.0f, 0.0f); glVertex3f(100.0f, 0.0f,  0.0f);
+  
+  glEnd();
 
-	// Turn off the depth buffer when rendering the background
-	// glDisable(GL_DEPTH_TEST);
+  this->shader->deactivateShader();
 
-	this->cloudShader->activateShader();
+  cloudMaterial.unselect();
 
-	/* Select the shader program and update parameters. */
-	/* The "time" parameter controls the cloud scrolling. */
-	this->cloudShader->bindShader("time", &time, 1);
-	/* The "horizon" parameter controls the sky tinting. */
-	this->cloudShader->bindShader("horizon", cloudTint, 4);
+  glPopMatrix();
 
-	glActiveTexture(GL_TEXTURE0 + 0);
-	glActiveTexture(GL_TEXTURE0 + 1);
-
-	// Load the cloud texture
-	//glBindTexture(GL_TEXTURE_2D, g_cloud_texture);
-	this->cloudMaterial->select();
-
-	// Render the sky dome
-	cloudModel.Render();
-
-	// Unselect the shader
-	Shader::deactivateShader();
-
-	/* Turn on the depth buffer when rendering the foreground. */
-	// glEnable(GL_DEPTH_TEST);
-
-	/* Render the forground, for example, a teapot or bunny. */
-	//    glEnable(GL_LIGHTING);
-	//    glColor3f(0.0f, 1.0f, 0.0f);
-	//    glBegin(GL_QUADS);
-	//    glNormal3f( 0.0f,  1.0f,  0.0f);
-	//    glVertex3f( 20.0f, -1.0f,  20.0f);
-	//    glVertex3f( 20.0f, -1.0f, -20.0f);
-	//    glVertex3f(-20.0f, -1.0f, -20.0f);
-	//    glVertex3f(-20.0f, -1.0f,  20.0f);
-	//    glEnd();
-	//    glDisable(GL_LIGHTING);
-
-	glPopMatrix();
-	
 }
 
 void CloudEffect::tick (float dt)
 {
-	if (!this->cloudActivate)
-		return;
-
-	// Update the timer for scrolling the clouds
-	time = time + ((1.0f / 2000.0f) * cloudScroll);
+	//if (!this->cloudActivate)
+	//	return;
 }
 
Index: /trunk/src/lib/graphics/effects/cloud_effect.h
===================================================================
--- /trunk/src/lib/graphics/effects/cloud_effect.h	(revision 8494)
+++ /trunk/src/lib/graphics/effects/cloud_effect.h	(revision 8495)
@@ -12,53 +12,42 @@
 
 #include "world_entity.h"
-#include "glincl.h"
+#include "material.h"
+#include "shader.h"
 
-#include "sglmodel.h"
+class CloudEffect : public WeatherEffect {
+public:
+    CloudEffect(const TiXmlElement* root = NULL);
+    virtual ~CloudEffect();
 
-class Shader;
-class Material;
-class Vector;
+    virtual void loadParams(const TiXmlElement* root);
 
-class CloudEffect : public WeatherEffect
-{
-	public:
-		CloudEffect(const TiXmlElement* root = NULL);
-		virtual ~CloudEffect();
+    virtual void init();
 
-		virtual void loadParams(const TiXmlElement* root);
+    virtual void activate();
+    virtual void deactivate();
 
-		virtual bool init();
+    inline void activateCloud() {
+        this->activate();
+    }
+    inline void deactivateCloud() {
+        this->deactivate();
+    }
 
-		virtual bool activate();
-		virtual bool deactivate();
+    virtual void draw() const;
+    virtual void tick(float dt);
 
-		inline void activateCloud() { this->activate(); }
-		inline void deactivateCloud() { this->deactivate(); }
-		
-		virtual void draw() const;
-		virtual void tick(float dt);
-
-		inline void setCloudOption(const std::string& option) {
-			if (option == "activate") this->cloudActivate = true;
-		}
+    /*inline void setCloudOption(const std::string& option) {
+        if (option == "activate")
+    this->cloudActivate = true;
+}*/
 
 
-	private:
-		void initialize(char* fileName);
+private:
+    //void initialize(char* fileName);
 
-		bool				cloudActivate;
+    //bool        cloudActivate;
 
-		Material*			cloudMaterial;		// A Material for the Sphere.
-
-		std::string			cloudTexture;
-
-		Sglmodel_sgl			cloudModel;
-		Shader*				cloudShader;
-
-		GLfloat				cloudTint[4];
-		GLfloat				cloudScroll;
-
-		float				time;
-
+    Material                 cloudMaterial;
+    Shader*                 shader;
 };
 
Index: /trunk/src/lib/graphics/effects/fog_effect.cc
===================================================================
--- /trunk/src/lib/graphics/effects/fog_effect.cc	(revision 8494)
+++ /trunk/src/lib/graphics/effects/fog_effect.cc	(revision 8495)
@@ -1,14 +1,14 @@
 /*
-	orxonox - the future of 3D-vertical-scrollers
-
-	Copyright (C) 2004 orx
-
-	This program is free software; you can redistribute it and/or modify
-	it under the terms of the GNU General Public License as published by
-	the Free Software Foundation; either version 2, or (at your option)
-	any later version.
+  orxonox - the future of 3D-vertical-scrollers
+
+  Copyright (C) 2004 orx
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2, or (at your option)
+  any later version.
 
 ### File Specific:
-	main-programmer: hdavid, amaechler
+  main-programmer: hdavid, amaechler
 */
 
@@ -22,5 +22,8 @@
 SHELL_COMMAND(activate, FogEffect, activateFog);
 SHELL_COMMAND(deactivate, FogEffect, deactivateFog);
-SHELL_COMMAND(startfogging, FogEffect, startFogging);
+SHELL_COMMAND(fadein, FogEffect, fadeInFog);
+SHELL_COMMAND(fadeout, FogEffect, fadeOutFog);
+
+// TODO: Fix fades
 
 using namespace std;
@@ -28,132 +31,177 @@
 CREATE_FACTORY(FogEffect, CL_FOG_EFFECT);
 
-FogEffect::FogEffect(const TiXmlElement* root)
-{
-	this->setClassID(CL_FOG_EFFECT, "FogEffect");
-
-	this->init();
-
-	if (root != NULL)
-		this->loadParams(root);
-
-	if (this->fogActivate)
-		this->activate();
-}
-
-
-FogEffect::~FogEffect()
-{
-	this->deactivate();
-}
-
-
-void FogEffect::loadParams(const TiXmlElement* root)
-{
-	WeatherEffect::loadParams(root);
-
-	LoadParam(root, "mode", this, FogEffect, setFogMode);
-	LoadParam(root, "density", this, FogEffect, setFogDensity);
-	LoadParam(root, "range", this, FogEffect, setFogRange);
-	LoadParam(root, "color", this, FogEffect, setFogColor);
-
-	LOAD_PARAM_START_CYCLE(root, element);
-	{
-		LoadParam_CYCLE(element, "option", this, FogEffect, setFogOption);
-	}
-	LOAD_PARAM_END_CYCLE(element);
-}
-
-bool FogEffect::init()
-{
-	//default values
-	this->fogActivate = false;
-	this->fogFadeDuration = 0;
-	this->localTimer = 0;
-
-	this->fogMode = GL_EXP2;
-	this->fogDensity = 0.001;
-	this->fogStart = 0;
-	this->fogEnd = 5000;
-	this->colorVector = Vector(0.7, 0.7, 0.7);
-
-        return true;
-}
-
-
-bool FogEffect::activate()
-{
-	PRINTF(0)( "Enabling FogEffect, mode: %i, density: %f, start: %f, end: %f, color %f, %f, %f\n", this->fogMode, this->fogDensity, this->fogStart, this->fogEnd, this->colorVector.x, this->colorVector.y, this->colorVector.z);
-
-	this->fogActivate = true;
-
-	GLfloat fogColor[4] = { colorVector.x, colorVector.y, colorVector.z, 1.0};
-	glFogi(GL_FOG_MODE, this->fogMode);
-	glFogfv(GL_FOG_COLOR, fogColor);
-	glFogf(GL_FOG_DENSITY, this->fogDensity);
-	glHint(GL_FOG_HINT, GL_DONT_CARE);
-	glFogf(GL_FOG_START, this->fogStart);
-	glFogf(GL_FOG_END, this->fogEnd);
-
-	glEnable(GL_FOG);
-	// glClearColor(0.5, 0.5, 0.5, 1.0);
-        return true;
-}
-
-
-bool FogEffect::deactivate()
-{
-	PRINTF(0)("Deactivating FogEffect\n");
-
-	this->fogActivate = false;
-
-	glDisable(GL_FOG);
-
-        return true;
+FogEffect::FogEffect(const TiXmlElement* root) {
+    this->setClassID(CL_FOG_EFFECT, "FogEffect");
+
+    this->init();
+
+    if (root != NULL)
+        this->loadParams(root);
+
+    if (this->fogActivate)
+        this->activate();
+}
+
+
+FogEffect::~FogEffect() {
+    this->deactivate();
+}
+
+
+void FogEffect::loadParams(const TiXmlElement* root) {
+    WeatherEffect::loadParams(root);
+
+    LoadParam(root, "mode", this, FogEffect, setFogMode);
+    LoadParam(root, "density", this, FogEffect, setFogDensity);
+    LoadParam(root, "range", this, FogEffect, setFogRange);
+    LoadParam(root, "color", this, FogEffect, setFogColor);
+    LoadParam(root, "fadeinduration", this, FogEffect, setFogFadeIn);
+    LoadParam(root, "fadeoutduration", this, FogEffect, setFogFadeOut);
+
+    LOAD_PARAM_START_CYCLE(root, element);
+    {
+        LoadParam_CYCLE(element, "option", this, FogEffect, setFogOption);
+    }
+    LOAD_PARAM_END_CYCLE(element);
+}
+
+void FogEffect::init() {
+    // default values
+    this->fogMode = GL_LINEAR;
+    this->fogDensity = 0.03;
+    this->fogStart = 0;
+    this->fogEnd = 50;
+    this->colorVector = Vector(0.3, 0.3, 0.3);
+
+    // init variables
+    this->fogFadeInDuration = 0;
+    this->fogFadeOutDuration = 0;
+    this->fogFadeDensity = 0;
+    this->localTimer = 0;
+    this->fogActivate = false;
+    this->fogFadeInActivate = false;
+    this->fogFadeOutActivate = false;
+
+}
+
+
+void FogEffect::activate() {
+    PRINTF(0)( "Enabling FogEffect, mode: %i, density: %f, start: %f, end: %f, color %f, %f, %f\n", this->fogMode, this->fogDensity, this->fogStart, this->fogEnd, this->colorVector.x, this->colorVector.y, this->colorVector.z);
+
+    this->fogActivate = true;
+
+    GLfloat fogColor[4] = { colorVector.x, colorVector.y, colorVector.z, 1.0};
+    glFogi(GL_FOG_MODE, this->fogMode);
+    glFogfv(GL_FOG_COLOR, fogColor);
+    glHint(GL_FOG_HINT, GL_DONT_CARE);
+    glFogf(GL_FOG_DENSITY, this->fogDensity);
+    glFogf(GL_FOG_START, this->fogStart);
+    glFogf(GL_FOG_END, this->fogEnd);
+
+    glEnable(GL_FOG);
+
+}
+
+
+void FogEffect::deactivate() {
+    PRINTF(0)("Deactivating FogEffect\n");
+
+    this->fogFadeInActivate = false;
+    this->fogFadeOutActivate = false;
+    this->fogActivate = false;
+
+    glDisable(GL_FOG);
+
 }
 
 void FogEffect::draw() const {
 
-	if (this->fogFadeDuration != 0 && this->localTimer < this->fogFadeDuration)
-		glFogf(GL_FOG_DENSITY, this->fogFadeDensity);
-	//else
-	//	glFogf(GL_FOG_DENSITY, this->fogDensity);
-
-}
-void FogEffect::tick(float dt)
-{
-	if (!this->fogActivate)
-		return;
-
-
-	if (this->fogFadeDuration != 0 && this->localTimer < this->fogFadeDuration) {
-		this->localTimer += dt;
-		float progress = this->localTimer / this->fogFadeDuration;
-		this->fogFadeDensity = progress * this->fogDensity;
-	}
-}
-
-void FogEffect::startFogging() {
-
-	if (this->fogActivate)
-		this->deactivate();
-
-	this->fogFadeDuration = 10;
-	this->localTimer = 0;
-	this->activate();
-
-}
-
-
-GLint FogEffect::stringToFogMode(const std::string& mode)
-{
-	if(mode == "GL_LINEAR")
-		return GL_LINEAR;
-	else if(mode == "GL_EXP")
-		return GL_EXP;
-	else if(mode == "GL_EXP2" )
-		return GL_EXP2;
-	else
-		return -1;
-}
-
-
+    if (!this->fogActivate)
+        return;
+
+    // If Fog Fade
+    if ( this->fogFadeInActivate || this->fogFadeOutActivate )
+        glFogf(GL_FOG_DENSITY, this->fogFadeDensity);
+
+}
+
+void FogEffect::tick(float dt) {
+    if (!this->fogActivate)
+        return;
+
+    if ( this->fogFadeInActivate ) {
+        this->localTimer += dt;
+        this->fogFadeDensity = ( this->localTimer / this->fogFadeInDuration ) * this->fogDensity;
+
+        if ( this->localTimer >= this->fogFadeOutDuration )
+            this->fogFadeInActivate = false;
+    }
+
+    if ( this->fogFadeOutActivate ) {
+        this->localTimer += dt;
+        this->fogFadeDensity = 1 - (( this->localTimer / this->fogFadeInDuration ) * this->fogDensity);
+
+        if ( this->localTimer >= this->fogFadeOutDuration )
+            this->deactivate();
+    }
+}
+
+void FogEffect::fadeInFog() {
+
+    // If Fog is already fading out, stop it
+    this->fogFadeOutActivate = false;
+
+    // If Fog is already on, turn it off first
+    if (this->fogActivate)
+        this->deactivate();
+
+    // If no manual FadeIn value was set, set a default value
+    if (!this->fogFadeInDuration > 0)
+        this->fogFadeInDuration = 20;
+
+    // Reset local timer
+    this->localTimer = 0;
+
+    // set FogFadeIn activate
+    this->fogFadeInActivate = true;
+
+    // Activate Fog
+    this->activate();
+
+}
+
+
+void FogEffect::fadeOutFog() {
+
+    // If Fog is already fading in, stop it
+    this->fogFadeInActivate = false;
+
+    // If Fog is off, turn it on first
+    if (!this->fogActivate)
+        this->activate();
+
+    // If no manual FadeOut value was set, set a default value
+    if (!this->fogFadeOutDuration > 0)
+        this->fogFadeOutDuration = 20;
+
+    // set FogFadeOut activate
+    this->fogFadeOutActivate = true;
+
+    // Reset local timer
+    this->localTimer = 0;
+
+}
+
+
+GLint FogEffect::stringToFogMode(const std::string& mode) {
+    if(mode == "GL_LINEAR")
+        return GL_LINEAR;
+    else if(mode == "GL_EXP")
+        return GL_EXP;
+    else if(mode == "GL_EXP2" )
+        return GL_EXP2;
+    else
+        return -1;
+}
+
+
Index: /trunk/src/lib/graphics/effects/fog_effect.h
===================================================================
--- /trunk/src/lib/graphics/effects/fog_effect.h	(revision 8494)
+++ /trunk/src/lib/graphics/effects/fog_effect.h	(revision 8495)
@@ -6,51 +6,80 @@
 #define _FOG_EFFECT
 
-#include "vector.h"
 
 #include "weather_effect.h"
 #include "glincl.h"
+#include "vector.h"
+
+class FogEffect : public WeatherEffect {
+public:
+    FogEffect(const TiXmlElement* root = NULL);
+    virtual ~FogEffect();
+
+    virtual void loadParams(const TiXmlElement* root);
+
+    virtual void init();
+
+    virtual void activate();
+    virtual void deactivate();
+
+    void activateFog() {
+        this->activate();
+    }
+    void deactivateFog() {
+        this->deactivate();
+    }
+
+    virtual void draw() const;
+    virtual void tick(float dt);
+
+    inline void setFogMode(const std::string& mode) {
+        this->fogMode = this->stringToFogMode(mode);
+    }
+    inline void setFogDensity(float density) {
+        this->fogDensity = density;
+    }
+    inline void setFogRange(float start, float end) {
+        this->fogStart = start;
+        this->fogEnd = end;
+    }
+    inline void setFogColor(float r, float g, float b) {
+        this->colorVector = Vector(r, g, b);
+    }
+    inline void setFogFadeIn(float fadein) {
+        this->fogFadeInDuration = fadein;
+    }
+    inline void setFogFadeOut(float fadeout) {
+        this->fogFadeOutDuration = fadeout;
+    }
+
+    inline void setFogOption(const std::string& option) {
+        if (option == "activate")
+            this->fogActivate = true;
+    }
+
+    void fadeInFog();
+    void fadeOutFog();
 
 
-class FogEffect : public WeatherEffect
-{
-	public:
-		FogEffect(const TiXmlElement* root = NULL);
-		virtual ~FogEffect();
+private:
+    GLint stringToFogMode(const std::string& mode);
 
-		virtual void loadParams(const TiXmlElement* root);
+    bool          fogActivate;
 
-		virtual bool init();
+    bool          fogFadeInActivate;
+    bool          fogFadeOutActivate;
 
-		virtual bool activate();
-		virtual bool deactivate();
+    GLfloat       fogFadeInDuration;
+    GLfloat       fogFadeOutDuration;
 
-		void activateFog() { this->activate(); }
-		void deactivateFog() { this->deactivate(); }
+    float         localTimer;
 
-		virtual void draw() const;
-		virtual void tick(float dt);
+    GLint         fogMode;
+    GLfloat       fogDensity;
+    GLfloat       fogFadeDensity;
 
-		inline void setFogMode(const std::string& mode) { this->fogMode = this->stringToFogMode(mode); }
-		inline void setFogDensity(float density) { this->fogDensity = density; }
-		inline void setFogRange(float start, float end) { this->fogStart = start; this->fogEnd = end; }
-		inline void setFogColor(float r, float g, float b) { this->colorVector = Vector(r, g, b); }
-		inline void setFogOption(const std::string& option) { if (option == "activate") this->fogActivate = true; }
-
-		void startFogging();
-
-	private:
-		GLint stringToFogMode(const std::string& mode);
-
-		bool				fogActivate;
-		GLfloat				fogFadeDuration;
-		float				localTimer;
-
-		GLint				fogMode;
-		GLfloat				fogDensity;
-		GLfloat				fogFadeDensity;
-
-		GLfloat				fogStart;
-		GLfloat				fogEnd;
-		Vector				colorVector;
+    GLfloat       fogStart;
+    GLfloat       fogEnd;
+    Vector        colorVector;
 };
 
Index: /trunk/src/lib/graphics/effects/graphics_effect.cc
===================================================================
--- /trunk/src/lib/graphics/effects/graphics_effect.cc	(revision 8494)
+++ /trunk/src/lib/graphics/effects/graphics_effect.cc	(revision 8495)
@@ -32,8 +32,7 @@
   @todo what to do, if no GraphicsEffect-Slots are open anymore ???
  */
-GraphicsEffect::GraphicsEffect(const TiXmlElement* root)
-{
-  this->setClassID(CL_GRAPHICS_EFFECT, "GraphicsEffect");
-  this->bActivated = false;
+GraphicsEffect::GraphicsEffect(const TiXmlElement* root) {
+    this->setClassID(CL_GRAPHICS_EFFECT, "GraphicsEffect");
+    this->bActivated = false;
 }
 
@@ -42,7 +41,5 @@
  *  destroys a GraphicsEffect
  */
-GraphicsEffect::~GraphicsEffect()
-{
-
+GraphicsEffect::~GraphicsEffect() {
 }
 
@@ -51,7 +48,6 @@
  * @param root The XML-element to load the GraphicsEffect from
  */
-void GraphicsEffect::loadParams(const TiXmlElement* root)
-{
-  BaseObject::loadParams(root);
+void GraphicsEffect::loadParams(const TiXmlElement* root) {
+    BaseObject::loadParams(root);
 }
 
@@ -60,8 +56,5 @@
  *  initializes the graphics effect
  */
-bool GraphicsEffect::init()
-{
-  return true;
-}
+void GraphicsEffect::init() {}
 
 
@@ -70,6 +63,5 @@
  * draws the effect, if needed
  */
-void GraphicsEffect::draw() const
-{}
+void GraphicsEffect::draw() const {}
 
 
@@ -78,4 +70,3 @@
  * ticks the effect if there is any time dependancy
  */
-void GraphicsEffect::tick(float dt)
-{}
+void GraphicsEffect::tick(float dt) {}
Index: /trunk/src/lib/graphics/effects/graphics_effect.h
===================================================================
--- /trunk/src/lib/graphics/effects/graphics_effect.h	(revision 8494)
+++ /trunk/src/lib/graphics/effects/graphics_effect.h	(revision 8495)
@@ -12,7 +12,6 @@
 
 //! A class that handles GraphicsEffects. The GraphicsEffectManager operates on this.
-class GraphicsEffect : public BaseObject
-{
-  public:
+class GraphicsEffect : public BaseObject {
+public:
     GraphicsEffect(const TiXmlElement* root = NULL);
     virtual ~GraphicsEffect();
@@ -20,16 +19,18 @@
     virtual void loadParams(const TiXmlElement* root);
 
-    virtual bool init();
+    virtual void init();
 
-    virtual bool activate() = 0;
-    virtual bool deactivate() = 0;
+    virtual void activate() = 0;
+    virtual void deactivate() = 0;
 
     virtual void draw() const;
     virtual void tick(float dt);
 
-    inline bool isActivated() const { return this->bActivated; }
+    inline bool isActivated() const {
+        return this->bActivated;
+    }
 
 
-  protected:
+protected:
     bool              bActivated;
 };
